const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const study_group_resources = sequelize.define(
    'study_group_resources',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title: {
        type: DataTypes.TEXT,
      
      

      },

url: {
        type: DataTypes.TEXT,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  study_group_resources.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.study_group_resources.belongsTo(db.study_groups, {
      as: 'study_group',
      foreignKey: {
        name: 'study_groupId',
      },
      constraints: false,
    });

    db.study_group_resources.belongsTo(db.users, {
      as: 'added_by',
      foreignKey: {
        name: 'added_byId',
      },
      constraints: false,
    });



    db.study_group_resources.hasMany(db.file, {
      as: 'files',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.study_group_resources.getTableName(),
        belongsToColumn: 'files',
      },
    });


    db.study_group_resources.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.study_group_resources.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return study_group_resources;
};


